hdu 5461 Largest Point (2015 ACM/ICPC Asia Regional Shenyang Online)

简介:

点击打开链接

Largest Point

Time Limit: 1500/1000 MS (Java/Others)    Memory Limit: 65535/32768 K (Java/Others)
Total Submission(s): 474    Accepted Submission(s): 213


Problem Description
Given the sequence  A with  n integers  t1,t2,,tn. Given the integral coefficients  a and  b. The fact that select two elements  ti and  tj of  A and  ij to maximize the value of  at2i+btj, becomes the largest point.
 

Input
An positive integer  T, indicating there are  T test cases.
For each test case, the first line contains three integers corresponding to  n (2n5×106), a (0|a|106) and  b (0|b|106). The second line contains  nintegers  t1,t2,,tn where  0|ti|106 for  1in.

The sum of  n for all cases would not be larger than  5×106.
 

Output
The output contains exactly  T lines.
For each test case, you should output the maximum value of  at2i+btj.
 

Sample Input
 
 
2 3 2 1 1 2 3 5 -1 0 -3 -3 0 3 3
 

Sample Output
 
 
Case #1: 20 Case #2: 0
 

Source

题目大意:有T组数据,然后第一行有三个数n, a, b;

接下来有n行arr[i],求a * arr[i] + b * arr[j] 的最大值(i != j)


解题思路:

分四种情况讨论,有点麻烦,但是却管用,先对arr数组排一下序,

然后在对绝对值数组data排一下序,在判断一下是不是绝对值数组的最值跟原先数组的最值一样,

最后在确定是不是有多个最值就okl



上代码:

/**
2015 - 09 - 20 中午

Author: ITAK

Motto:

今日的我要超越昨日的我,明日的我要胜过今日的我,
以创作出更好的代码为目标,不断地超越自己。
**/
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <algorithm>
#include <set>
using namespace std;
typedef long long LL;
const int maxn = 5*1e6+5;
const double eps = 1e-7;
LL arr[maxn], data[maxn];

int main()
{
    int T;
    scanf("%d",&T);
    for(int cas=1; cas<=T; cas++)
    {
        int m, a, b;
        scanf("%d%d%d",&m,&a,&b);
        for(int i=0; i<m; i++)
        {
            scanf("%lld",&arr[i]);
            data[i] = abs(arr[i]);
        }
        sort(data, data+m);
        sort(arr, arr+m);
        LL ans;
        if(a < 0)
        {
            if(b <= 0)
            {
                if(abs(arr[0]) != data[0])
                {
                    ans = data[0]*data[0]*a + arr[0]*b;
                }
                else
                {
                    if(data[0] != data[1])
                        ans = data[0]*data[0]*a + arr[1]*b;
                    else
                        ans = data[0]*data[0]*a + arr[0]*b;
                }
            }
            else
            {
                if(abs(arr[m-1]) != data[0])
                {
                    ans = data[0]*data[0]*a + arr[m-1]*b;
                }
                else
                {
                    if(data[0] != data[1])
                        ans = data[0]*data[0]*a + arr[m-2]*b;
                    else
                        ans = data[0]*data[0]*a + arr[m-1]*b;
                }
            }
        }
        else
        {
            if(b <= 0)
            {
                if(abs(arr[0]) != data[m-1])
                {
                    ans = data[m-1]*data[m-1]*a + arr[0]*b;
                }
                else
                {
                    if(data[m-1] != data[m-2])
                        ans = data[m-1]*data[m-1]*a + arr[1]*b;
                    else
                        ans = data[m-1]*data[m-1]*a + arr[0]*b;
                }
            }
            else
            {
                if(abs(arr[m-1]) != data[m-1])
                {
                    ans = data[m-1]*data[m-1]*a + arr[m-1]*b;
                }
                else
                {
                    if(data[m-1] != data[m-2])
                        ans = data[m-1]*data[m-1]*a + arr[m-2]*b;
                    else
                        ans = data[m-1]*data[m-1]*a + arr[m-1]*b;
                }
            }
        }
        printf("Case #%d: %lld\n",cas, ans);
    }
    return 0;
}


目录
相关文章
Leetcode 365. Water and Jug Problem
一句话理解题意:有容积为x和y升的俩水壶,能不能量出z升的水。 我刚开始看到这题,立马就想了下暴力搜索的可能性,但考虑了下数据大小,立马放弃这个暴力的想法,于是意识到肯定有比较简单的数学方法,其实我自己没想到,后来看还是看了别人的代码,很多博客都直接给出了解法, 但没介绍为什么能这么解。所以我决定解释下我自己的思路。
46 0
2021 ICPC Asia Regionals Online Contest (II) Problem G. Limit
2021 ICPC Asia Regionals Online Contest (II) Problem G. Limit
|
机器学习/深度学习
The Preliminary Contest for ICPC China Nanchang National Invitational J题 Distance on the tree
The Preliminary Contest for ICPC China Nanchang National Invitational J题 Distance on the tree
89 0
The Preliminary Contest for ICPC China Nanchang National Invitational A题 PERFECT NUMBER PROBLEM
The Preliminary Contest for ICPC China Nanchang National Invitational A题 PERFECT NUMBER PROBLEM
67 0
|
机器学习/深度学习 人工智能
The Preliminary Contest for ICPC China Nanchang National Invitational I题 Max answer
The Preliminary Contest for ICPC China Nanchang National Invitational I题 Max answer
92 0
The Preliminary Contest for ICPC China Nanchang National Invitational H题 Coloring Game
The Preliminary Contest for ICPC China Nanchang National Invitational H题 Coloring Game
86 0
The Preliminary Contest for ICPC China Nanchang National Invitational M题 Subsequence
The Preliminary Contest for ICPC China Nanchang National Invitational M题 Subsequence
72 0
LeetCode 365. Water and Jug Problem
有两个容量分别为 x升 和 y升 的水壶以及无限多的水。请判断能否通过使用这两个水壶,从而可以得到恰好 z升 的水?
80 0
LeetCode 365. Water and Jug Problem
|
机器学习/深度学习 BI
2020-2021 ACM-ICPC, Asia Seoul Regional Contest L. Two Buildings (决策单调性 分治)
2020-2021 ACM-ICPC, Asia Seoul Regional Contest L. Two Buildings (决策单调性 分治)
131 0
2020-2021 ACM-ICPC, Asia Seoul Regional Contest L. Two Buildings (决策单调性 分治)